// SimpleWell Chest Mod v1.01
// Script By: Mr. Doom (Duh it says Simple)
// Model By: Pandan (Duh it says Well)
//
// 1.0
//  - Public Release
// 1.01
//  - Minor bugfix
package iChest
{
	function armor::onCollision(%this, %obj, %col, %fade, %pos, %normal)
	{
		parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		if(%obj.getClassName() !$= "AIPlayer")
			return;
		if(%col.getClassName() $= "Item" && %obj.getDatablock().isContainer)
		{
			%client = findClientByBL_ID(%col.BL_ID);
			if(getFieldCount(%obj.ToolStore) < %obj.getDatablock().MaxTools)
			{
				if(striPos("\t"@%obj.ToolStore@"\t","\t"@%col.getDatablock().getName()@"\t")<0)
				{
					%obj.ToolStore=trim(%obj.ToolStore TAB %col.getDatablock().getName());
					%col.delete();
					messageClient(%client,'CHESTCONTENTHEADER',"\c7== Chest Contents (\c2"@mFloor((getFieldCount(%obj.ToolStore)/%obj.getDatablock().maxTools)*100)@"% FULL\c7):");
					for(%i=0;%i<getFieldCount(%obj.ToolStore);%i++)
					{
						%data = trim(%data SPC "\c7|\c6" SPC nameToID(getField(%obj.ToolStore,%i)).UINAME);
						%d++;
						if(%d>=7)
						{
							messageClient(%client,'CHESTCONTENTDATA',%data);
							%data="";
							%d=0;
						}
					}
					if(%data !$= "")
						messageClient(%client,'CHESTCONTENTDATA',%data);
				}
				else
					messageClient(%Client,"","\c3Chest\c6: I already have this tool.");
			}
			else
				messageClient(%Client,"","\c3Chest\c6: I am full.");
		}
	}
	// Thanks Amade
	function player::activateStuff(%this)
	{
		parent::activateStuff(%this);
		%start = %this.getEyePoint();
		%end = vectorAdd(%start, vectorScale(%this.getEyeVector(), 5));
		%ray = containerRayCast(%start, %end, $Typemasks::PlayerObjectType, %this);
		if(isObject(%hit = getWord(%ray, 0)))
		{
			if(%hit.getClassName() $= "AIPlayer" && %hit.getDatablock().isContainer)
			{
				%client = %this.client;
				%hit.ToolStore = strReplace(trim(%hit.ToolStore),"\t\t","\t");
				if(getFieldCount(%hit.ToolStore)<=0)
				{
					MessageClient(%client,"","\c3Chest\c6: This chest is empty.");
					return;
				}
				for(%i=0;%i<%this.getDatablock().maxTools;%i++)
				{
					%tool = %client.player.tool[%i];
					if(!isObject(%tool))
					{
						%f=1;
						break;
					}
				}
				if(!%f)
				{
					MessageClient(%client,"","\c3Chest\c6: You cannot hold any more items!");
					return;
				}
				messageClient(%client,'CHESTCONTENTHEADER',"\c7== Chest Contents:");
				%data = "\c7|\c0" SPC nameToID(getField(%hit.ToolStore,0)).UINAME;
				%d = 1;
				for(%i=1;%i<getFieldCount(%hit.ToolStore);%i++)
				{
					%data = trim(%data SPC "\c7|\c6" SPC nameToID(getField(%hit.ToolStore,%i)).UINAME);
					%d++;
					if(%d>=7)
					{
						messageClient(%client,'CHESTCONTENTDATA',%data);
						%data="";
						%d=0;
					}
				}
				if(%data !$= "")
					messageClient(%client,'CHESTCONTENTDATA',%data);
				%ITEM = nameToID(getField(%hit.ToolStore,0));
				if(getFieldCount(%hit.ToolStore) <= 1)
					%hit.ToolStore = "";
				else
					%hit.ToolStore = getSubStr(%hit.ToolStore,striPos(%hit.ToolStore,"\t")+1,strLen(%hit.ToolStore));
				%hit.playThread(0,"Open");
				cancel(%hit.closeSchedule);
				%hit.closeSchedule = %hit.schedule(750,"playThread",0,"Close");
				%client.player.weaponCount++;
				%client.player.tool[%i] = %ITEM;
				messageClient(%client,'MsgItemPickup',"",%i,%ITEM);
				MessageClient(%Client,"","\c6You withdrew a "@%ITEM.UINAME@".");
			}
		}
	}
};
activatePackage(iChest);

//Chest Player Block
datablock TSShapeConstructor(ChestDts)
{
	baseShape  = "./Chestb.dts";
	sequence0  = "./Chest_root.dsq root";

	sequence1  = "./Chest_root.dsq run";
	sequence2  = "./Chest_root.dsq walk";
	sequence3  = "./Chest_root.dsq back";
	sequence4  = "./Chest_root.dsq side";

	sequence5  = "./Chest_open.dsq crouch";
	sequence6  = "./Chest_root.dsq crouchRun";
	sequence7  = "./Chest_root.dsq crouchBack";
	sequence8  = "./Chest_root.dsq crouchSide";

	sequence9  = "./Chest_root.dsq look";
	sequence10 = "./Chest_root.dsq headside";
	sequence11 = "./Chest_root.dsq headUp";

	sequence12 = "./Chest_close.dsq jump";
	sequence13 = "./Chest_root.dsq standjump";
	sequence14 = "./Chest_root.dsq fall";
	sequence15 = "./Chest_root.dsq land";

	sequence16 = "./Chest_root.dsq armAttack";
	sequence17 = "./Chest_root.dsq armReadyLeft";
	sequence18 = "./Chest_root.dsq armReadyRight";
	sequence19 = "./Chest_root.dsq armReadyBoth";
	sequence20 = "./Chest_root.dsq spearready";  
	sequence21 = "./Chest_root.dsq spearThrow";

	sequence22 = "./Chest_root.dsq talk";  

	sequence23 = "./Chest_root.dsq death1"; 
	
	sequence24 = "./Chest_root.dsq shiftUp";
	sequence25 = "./Chest_root.dsq shiftDown";
	sequence26 = "./Chest_root.dsq shiftAway";
	sequence27 = "./Chest_root.dsq shiftTo";
	sequence28 = "./Chest_root.dsq shiftLeft";
	sequence29 = "./Chest_root.dsq shiftRight";
	sequence30 = "./Chest_root.dsq rotCW";
	sequence31 = "./Chest_root.dsq rotCCW";

	sequence32 = "./Chest_root.dsq undo";
	sequence33 = "./Chest_root.dsq plant";

	sequence34 = "./Chest_root.dsq sit";

	sequence35 = "./Chest_root.dsq wrench";

   	sequence36 = "./Chest_root.dsq activate";
   	sequence37 = "./Chest_root.dsq activate2";

   	sequence38 = "./Chest_root.dsq leftrecoil";
};    
datablock PlayerData(PlayerChest : HorseArmor)
{
	shapefile = "./chestb.dts";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	
	className = Armor;
	uiName = "Container-Chest";
	showEnergyBar = false;
	maxItems   = 10;	//total number of bricks the container can hold (WIP)
	maxWeapons = 15;		//this will be controlled by mini-game code
	maxTools = 15;
	maxDamage = 1000000;
	isContainer = 1;

	rideable = true;
	
	numMountPoints = 0;
};
function PlayerChest::onAdd(%this,%obj)
{
   // Vehicle timeout
   %obj.mountVehicle = true;

   // Default dynamic armor stats
   %obj.setRepairRate(0);

}